Bug 865825 - Self-heal checks skip pending counts that they shouldn't
Self-heal checks skip pending counts that they shouldn't
Product: GlusterFS
Classification: Community
Component: replicate (Show other bugs)
Unspecified All
high Severity high
: ---
: ---
Assigned To: Jeff Darcy
Depends On:
Blocks: 867360 867364
  Show dependency treegraph
Reported: 2012-10-12 10:21 EDT by Jeff Darcy
Modified: 2013-07-24 13:19 EDT (History)
1 user (show)

See Also:
Fixed In Version: glusterfs-3.4.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 867360 867364 (view as bug list)
Last Closed: 2013-07-24 13:19:21 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Jeff Darcy 2012-10-12 10:21:37 EDT
The afr_sh_has_*_pending pending functions, which were clearly copied from one another, all have the problem that if they get an error from dict_get_ptr they return immediately.  This means they won't check the pending counts for other peers, which should trigger self-heal if they're non-zero.  Failing to trigger self-heal when we should makes this a high-priority issue.
Comment 1 Jeff Darcy 2012-10-19 09:36:41 EDT
http://review.gluster.org/#change,4070 should address this (along with some performance/readability issues).
Comment 2 Vijay Bellur 2012-11-27 00:34:44 EST
CHANGE: http://review.gluster.org/4070 (replicate: don't stop checking xattrs because one was absent) merged in master by Anand Avati (avati@redhat.com)
Comment 3 Vijay Bellur 2012-11-28 01:42:33 EST
CHANGE: http://review.gluster.org/4242 (tests/bug-865825: turn stat-prefetch off before doing any afr self-heal                   related tests.) merged in master by Vijay Bellur (vbellur@redhat.com)
Comment 4 Vijay Bellur 2012-12-03 03:30:02 EST
CHANGE: http://review.gluster.org/4253 (tests: Perform self-heal in foreground) merged in master by Vijay Bellur (vbellur@redhat.com)

Note You need to log in before you can comment on or make changes to this bug.